
#include <objbase.h>
#include <initguid.h>
#include <stdio.h>

class ILowerStr	: public IUnknown
{
public:
    virtual STDMETHODIMP Lower(char *lpInput, char**lpOutput) = 0;
};


const CLSID CLSID_CLowerStr =
{0x4f126d90, 0x1319, 0x11d0, {0xa6, 0xac, 0x0, 0xaa, 0x0, 0x60, 0x25, 0x53}};
																					
const CLSID IID_ILowerStr = 
{0x4f126d91, 0x1319, 0x11d0, {0xa6, 0xac, 0x0, 0xaa, 0x0, 0x60, 0x25, 0x53}};


void main()
{

    HRESULT hr;
 	ILowerStr  *pILowerStr; 
	

	hr = CoInitialize(NULL);

	if(FAILED(hr))
	{
		printf("CoInitialize failed[0x%x]\n", hr);
		exit(1);
	}

	//Create an instance of the COM object 
	hr = CoCreateInstance(CLSID_CLowerStr, NULL, CLSCTX_INPROC_SERVER,
	     IID_ILowerStr,(void**) &pILowerStr); 

	if(FAILED(hr))
	{
		printf("CoCreateInstance failed[0x%x]\n", hr);
		if(hr == REGDB_E_CLASSNOTREG)
            printf("please register the class\n");
        exit(1);
	}

	char *lpOutput;

	pILowerStr->Lower("hEllo World", &lpOutput);
	printf("the output is %s\n", lpOutput);

    pILowerStr->Release();
    CoUninitialize();	
}